Subject: [rohc] Incompatible feedback format 'size' field in RFC 3095 and RFC 4995

From: Suneeta Rao <[email-masked]>
Date: Sat, 12 Jul 2008 04:11:00 -0700 (PDT)

Dear ROHCers,
 
I am implementing simulation for RFC 3095 and RFC 4995/5225. I was going through feedback formats of RFC 4995 when I realized the the interpretation of 'size' field is different for RFC 3095 / 4995.. This came as a suprise to me because RFC 4995 is not supposed to outdate RFC 3095. It was only supposed to extract the framework part out of RFC 3095.
 
In RFC 4995 Section 5.2.4.1, the 'size' field covers the "Feedback data", i.e. it excludes the Add-CID / Large-CID Octets.
 
In RFC 3095 Section 5.2.2, the 'size' field covers the "Feedback data", but the Feedback data includes the Add-CID / Large-CID Octets.
 
I don't find any obvious reason for the above incompatibility. Can someone please comment on why the interpretation of 'size' field was changed? Doesn't RFC 4995 really update RFC 3095 atleast here?
 
Best Regards,
Suneeta Rao.
Email: [email-masked]
 
Excerpts from RFC 3095
--------------------------
 
5.2.2.  ROHC feedback format

     0   1   2   3   4   5   6   7
   +---+---+---+---+---+---+---+---+
   | 1   1   1   1   0 |   Code    |  feedback type octet
   +---+---+---+---+---+---+---+---+
   :             Size              :  if Code = 0
   +---+---+---+---+---+---+---+---+
   /         feedback data         /  variable length
   +---+---+---+---+---+---+---+---+

   Size: Optional octet indicating the size of the feedback data
         field in octets.

   feedback data: Profile-specific feedback information.  Includes
         CID information.

Excerpt from RFC 4995
---------------------
5.2.4..1.  ROHC Feedback Format
 
     0   1   2   3   4   5   6   7
   +---+---+---+---+---+---+---+---+
   | 1   1   1   1   0 |   Code    |  feedback type
   +---+---+---+---+---+---+---+---+
   :             Size              :  if Code = 0
   +---+---+---+---+---+---+---+---+
   :         Add-CID octet         :  if for small CIDs and (CID != 0)
   +---+---+---+---+---+---+---+---+
   :                               :
   /  large CID (5.3.2 encoding)   /  1-2 octets if for large CIDs
   :                               :
   +---+---+---+---+---+---+---+---+
   /         FEEDBACK data         /  variable length
   +---+---+---+---+---+---+---+---+

   Size: Indicates the size of the feedback data field, in octets.

--------------------------------------------------------
 
[suneeta] As you can see above, RFC 4995 indicates that CID is not part of size field.

_______________________________________________
Rohc mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/rohc

---

From: "Ghyslain Pelletier" <[email-masked]>
Date: Sat, 12 Jul 2008 13:37:02 +0200

Hi
 
Thanks for pointing this inconsistency.
 
This error has already been reported to the authors and to the chairman.
 
The intent in RFC4995 was to handle the size field in the exact same
manner as in RFC3095, i.e. RFC4995 does not update RFC3095.
 
In this case until the error is fixed in an updated RFC4995, please do
as per RFC3095.
 
We are working on an update to RFC4995 that will fix this.
 
Cheers,
 
///Ghyslain

________________________________

	From: [email-masked] [mailto:[email-masked]] On
Behalf Of Suneeta Rao
	Sent: den 12 juli 2008 13:11
	To: [email-masked]
	Subject: [rohc] Incompatible feedback format 'size' field in RFC
3095 andRFC 4995

	Dear ROHCers,
	 
	I am implementing simulation for RFC 3095 and RFC 4995/5225. I
was going through feedback formats of RFC 4995 when I realized the the
interpretation of 'size' field is different for RFC 3095 / 4995. This
came as a suprise to me because RFC 4995 is not supposed to outdate RFC
3095. It was only supposed to extract the framework part out of RFC
3095.
	 
	In RFC 4995 Section 5.2.4.1, the 'size' field covers the
"Feedback data", i.e. it excludes the Add-CID / Large-CID Octets.
	 
	In RFC 3095 Section 5.2.2, the 'size' field covers the "Feedback
data", but the Feedback data includes the Add-CID / Large-CID Octets.
	 
	I don't find any obvious reason for the above incompatibility.
Can someone please comment on why the interpretation of 'size' field was
changed? Doesn't RFC 4995 really update RFC 3095 atleast here?
	 
	Best Regards,
	Suneeta Rao.
	Email: [email-masked] <mailto:[email-masked]> 
	 
	Excerpts from RFC 3095

	     0   1   2   3   4   5   6   7

	   feedback data: Profile-specific feedback information.
Includes
	         CID information.

	Excerpt from RFC 4995
	---------------------
	5.2.4.1.  ROHC Feedback Format
	 
	     0   1   2   3   4   5   6   7
	   +---+---+---+---+---+---+---+---+
	   | 1   1   1   1   0 |   Code    |  feedback type
	   +---+---+---+---+---+---+---+---+
	   :             Size              :  if Code = 0
	   +---+---+---+---+---+---+---+---+
	   :         Add-CID octet         :  if for small CIDs and (CID
!= 0)
	   +---+---+---+---+---+---+---+---+
	   :                               :
	   /  large CID (5.3.2 encoding)   /  1-2 octets if for large
CIDs
	   :                               :
	   +---+---+---+---+---+---+---+---+
	   /         FEEDBACK data         /  variable length
	   +---+---+---+---+---+---+---+---+

	   Size: Indicates the size of the feedback data field, in
octets.

	[suneeta] As you can see above, RFC 4995 indicates that CID is
not part of size field.